"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reactNative = require("react-native");

var _schemas = require("../schemas");

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const {
  GenericClient: NativeGenericClient
} = _reactNative.NativeModules;

/**
 * Generic client for making requests
 */
class GenericClient {
  constructor() {
    _defineProperty(this, "head", (url, options) => {
      (0, _schemas.validateRequestOptions)(options);
      return NativeGenericClient.head(url, options);
    });

    _defineProperty(this, "get", (url, options) => {
      (0, _schemas.validateRequestOptions)(options);
      return NativeGenericClient.get(url, options);
    });

    _defineProperty(this, "put", (url, options) => {
      (0, _schemas.validateRequestOptions)(options);
      return NativeGenericClient.put(url, options);
    });

    _defineProperty(this, "post", (url, options) => {
      (0, _schemas.validateRequestOptions)(options);
      return NativeGenericClient.post(url, options);
    });

    _defineProperty(this, "patch", (url, options) => {
      (0, _schemas.validateRequestOptions)(options);
      return NativeGenericClient.patch(url, options);
    });

    _defineProperty(this, "delete", (url, options) => {
      (0, _schemas.validateRequestOptions)(options);
      return NativeGenericClient.delete(url, options);
    });
  }

}

var _default = new GenericClient();

exports.default = _default;
//# sourceMappingURL=index.js.map