function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// Copyright (c) 2015-present Mattermost, Inc. All Rights Reserved.
// See LICENSE.txt for license information.
import { NativeModules } from "react-native";
import { validateRequestOptions } from "../schemas";
const {
  GenericClient: NativeGenericClient
} = NativeModules;

/**
 * Generic client for making requests
 */
class GenericClient {
  constructor() {
    _defineProperty(this, "head", (url, options) => {
      validateRequestOptions(options);
      return NativeGenericClient.head(url, options);
    });

    _defineProperty(this, "get", (url, options) => {
      validateRequestOptions(options);
      return NativeGenericClient.get(url, options);
    });

    _defineProperty(this, "put", (url, options) => {
      validateRequestOptions(options);
      return NativeGenericClient.put(url, options);
    });

    _defineProperty(this, "post", (url, options) => {
      validateRequestOptions(options);
      return NativeGenericClient.post(url, options);
    });

    _defineProperty(this, "patch", (url, options) => {
      validateRequestOptions(options);
      return NativeGenericClient.patch(url, options);
    });

    _defineProperty(this, "delete", (url, options) => {
      validateRequestOptions(options);
      return NativeGenericClient.delete(url, options);
    });
  }

}

export default new GenericClient();
//# sourceMappingURL=index.js.map